﻿using UnityEngine;
using System.Collections;

public class Dude : MonoBehaviour {
	public ArrayList poses;
	public Vector3 [] defaultPose;
	public Vector2 [] defaultUvs;
	public int [] indices;
	public Mesh mesh;
	float meshw;
	public float size=1.0f;

	public Vector3 headPosition;
	private int headIndex = 0; // Quite arbitrary...


	private PlayerMove _playerMove;

	// Use this for initialization
	void InitMesh() {
		mesh = new Mesh ();
		GetComponent<MeshFilter> ().mesh = mesh;
		
		poses = new ArrayList ();
		//poses = new Vector3[][]();
		//Vector3 [] v1 = {new Vector3(8f, 90f, 0.0f),new Vector3(195f, 121f, 0.0f),new Vector3(76f, 63f, 0.0f),new Vector3(-57f, 63f, 0.0f),new Vector3(22f, -37f, 0.0f),new Vector3(-42f, 15f, 0.0f),new Vector3(-164f, 117f, 0.0f),new Vector3(72f, 26f, 0.0f),new Vector3(132f, -138f, 0.0f),new Vector3(-95f, -140f, 0.0f)};
		Vector3 [] v1 = {new Vector3(6f, 103f, 0.0f),new Vector3(122f, 160f, 0.0f),new Vector3(38f, 82f, 0.0f),new Vector3(-21f, 79f, 0.0f),new Vector3(12f, -27f, 0.0f),new Vector3(-18f, -3f, 0.0f),new Vector3(-111f, 137f, 0.0f),new Vector3(39f, 2f, 0.0f),new Vector3(63f, -153f, 0.0f),new Vector3(-90f, -109f, 0.0f)};
		Vector2 [] uvs = {new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f)};
		mesh.vertices = v1;
		defaultPose = v1;

		mesh.uv = uvs;
		defaultUvs = uvs;

		int [] inds = {0,1,2,3,4,5,0,3,6,0,4,3,2,4,0,7,4,2,4,7,8,9,5,4};

		mesh.triangles = inds;
		mesh.RecalculateBounds();
		meshw = mesh.bounds.size.x;
		
		headPosition = defaultPose [headIndex];
		
		// Add poses
		
		poses.Add (defaultPose);
		
		
		// L
		{
			Vector3 [] verts = {new Vector3(-90f, 2.99997f, 0.0f),new Vector3(-121f, 130f, 0.0f),new Vector3(-60f, 43f, 0.0f),new Vector3(-54f, -36f, 0.0f),new Vector3(42f, 0f, 0.0f),new Vector3(10f, -50f, 0.0f),new Vector3(-64f, -121f, 0.0f),new Vector3(20f, 63f, 0.0f),new Vector3(165f, 109f, 0.0f),new Vector3(165f, -78f, 0.0f)};
			poses.Add(verts);
		}
		
		// BL
		{
			Vector3 [] verts = {new Vector3(-67.6608f, -59.4223f, 0.0f),new Vector3(-154f, -17f, 0.0f),new Vector3(-77f, -14f, 0.0f),new Vector3(-13f, -68f, 0.0f),new Vector3(30.6167f, 28.751f, 0.0f),new Vector3(41f, -22f, 0.0f),new Vector3(-29f, -182f, 0.0f),new Vector3(-23f, 53f, 0.0f),new Vector3(-29f, 174f, 0.0f),new Vector3(127f, 95f, 0.0f)};
			poses.Add(verts);
		}
		
		// B
		{
			Vector3 [] verts = {new Vector3(-3.00003f, -90f, 0.0f),new Vector3(-68f, -216f, 0.0f),new Vector3(-41f, -50f, 0.0f),new Vector3(34f, -49f, 0.0f),new Vector3(-3.05176e-05f, 42f, 0.0f),new Vector3(42f, 14f, 0.0f),new Vector3(56f, -219f, 0.0f),new Vector3(-47f, 17f, 0.0f),new Vector3(-108f, 177f, 0.0f),new Vector3(99f, 179f, 0.0f)};
			poses.Add(verts);
		}
		
		// BR
		{
			Vector3 [] verts = {new Vector3(59.4223f, -67.6608f, 0.0f),new Vector3(-13.0827f, -168.671f, 0.0f),new Vector3(2.72223f, -93.4697f, 0.0f),new Vector3(61f, -16f, 0.0f),new Vector3(-28.751f, 30.6167f, 0.0f),new Vector3(24f, 30f, 0.0f),new Vector3(224f, -97f, 0.0f),new Vector3(-44f, -15f, 0.0f),new Vector3(-108f, 109f, 0.0f),new Vector3(45f, 190f, 0.0f)};
			poses.Add(verts);
		}
		
		// R
		{
			Vector3 [] verts = {new Vector3(90f, -3f, 0.0f),new Vector3(153f, -126f, 0.0f),new Vector3(67f, -45f, 0.0f),new Vector3(61f, 43f, 0.0f),new Vector3(-40f, 17f, 0.0f),new Vector3(-10f, 50f, 0.0f),new Vector3(133f, 145f, 0.0f),new Vector3(-15f, -36f, 0.0f),new Vector3(-174f, 15f, 0.0f),new Vector3(-160f, 129f, 0.0f)};
			poses.Add(verts);
		}
		
		
		// TR
		{
			Vector3 [] verts = {new Vector3(57f, 67f, 0.0f),new Vector3(191f, -31f, 0.0f),new Vector3(58f, 11f, 0.0f),new Vector3(5f, 73f, 0.0f),new Vector3(-28.751f, -30.6167f, 0.0f),new Vector3(-36f, 13f, 0.0f),new Vector3(-47f, 174f, 0.0f),new Vector3(31f, -34f, 0.0f),new Vector3(-58f, -142f, 0.0f),new Vector3(-202.159f, 16.993f, 0.0f)};
			poses.Add(verts);
		}
		
		// T
		{
			Vector3 [] verts = {new Vector3(8.64523f, 89.634f, 0.0f),new Vector3(135f, 171f, 0.0f),new Vector3(66.2729f, 65.9688f, 0.0f),new Vector3(-47f, 64f, 0.0f),new Vector3(6f, -44f, 0.0f),new Vector3(-35f, -11f, 0.0f),new Vector3(-132.81f, 134.605f, 0.0f),new Vector3(49f, -24f, 0.0f),new Vector3(47f, -202f, 0.0f),new Vector3(-53f, -227f, 0.0f)};
			poses.Add(verts);
		}
		

		// TL
		{
			Vector3 [] verts = {new Vector3(-87f, 81f, 0.0f),new Vector3(66f, 103f, 0.0f),new Vector3(-7f, 73f, 0.0f),new Vector3(-94f, 29f, 0.0f),new Vector3(28.751f, -30.6167f, 0.0f),new Vector3(-29.603f, -41.5171f, 0.0f),new Vector3(-161f, -13f, 0.0f),new Vector3(59.616f, 28.5471f, 0.0f),new Vector3(182f, 55f, 0.0f),new Vector3(145f, -105f, 0.0f)};
			poses.Add(verts);
		}


		/* OLDDUDE headIndex = 6
		Vector3 [] v1 = {new Vector3(-110.669f, 70.183f, 0.0f),new Vector3(-132.067f, 24.138f, 0.0f),new Vector3(-204.9f, 137.907f, 0.0f),new Vector3(-63.9446f, 3.51334f, 0.0f),new Vector3(-4.35437f, -37.3402f, 0.0f),new Vector3(-46.2422f, -64.8067f, 0.0f),new Vector3(2.5575f, 83.4788f, 0.0f),new Vector3(33.3777f, -56.7643f, 0.0f),new Vector3(40.1022f, 17.6654f, 0.0f),new Vector3(75.4832f, 88.6597f, 0.0f),new Vector3(86.0944f, 36.5789f, 0.0f),new Vector3(166.548f, 165.68f, 0.0f),new Vector3(-78.8448f, -173.752f, 0.0f),new Vector3(-98.3757f, -35.1065f, 0.0f),new Vector3(79.9648f, -18.6246f, 0.0f),new Vector3(98.1065f, -138.294f, 0.0f)};
		mesh.vertices = v1;
		defaultPose = v1;
		Vector2 [] uvs = {new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f),new Vector2(0.0f, 0.0f)};
		mesh.uv = uvs;
		defaultUvs = uvs;
		int [] inds = {0,1,2,0,3,1,3,4,5,0,4,3,6,4,0,6,7,4,6,8,7,9,8,6,9,10,8,10,9,11,3,12,13,12,3,5,14,7,8,7,14,15};
		mesh.triangles = inds;
		mesh.RecalculateBounds();
		meshw = mesh.bounds.size.x;
		
		headPosition = defaultPose [headIndex];

		// Add poses
		
		poses.Add (defaultPose);
		
		
		// L
		{
			Vector3 [] verts = {new Vector3(-109f, -63.5f, 0.0f),new Vector3(-107f, -103.5f, 0.0f),new Vector3(-253f, -74.5f, 0.0f),new Vector3(-15.4331f, -62.1536f, 0.0f),new Vector3(35.8629f, -11.2741f, 0.0f),new Vector3(54.9938f, -57.5667f, 0.0f),new Vector3(-81.5209f, 18.1545f, 0.0f),new Vector3(62.0132f, 22.1498f, 0.0f),new Vector3(-9.83817f, 42.702f, 0.0f),new Vector3(-86f, 56.5f, 0.0f),new Vector3(-23f, 84.5f, 0.0f),new Vector3(-268f, 85.5f, 0.0f),new Vector3(165f, -54.5f, 0.0f),new Vector3(16.051f, -103.211f, 0.0f),new Vector3(33.2786f, 75.0585f, 0.0f),new Vector3(207f, -65.5f, 0.0f)};
			poses.Add(verts);
		}
		
		// BL
		{
			Vector3 [] verts = {new Vector3(-20f, -111.5f, 0.0f),new Vector3(65.5839f, -117.145f, 0.0f),new Vector3(-113f, -181.5f, 0.0f),new Vector3(38.0527f, -51.5096f, 0.0f),new Vector3(47f, 32.5f, 0.0f),new Vector3(93f, 16.5f, 0.0f),new Vector3(-65.9517f, -51.2408f, 0.0f),new Vector3(22.4619f, 61.9008f, 0.0f),new Vector3(-39.1735f, 19.6389f, 0.0f),new Vector3(-116.428f, 1.647f, 0.0f),new Vector3(-83.0631f, 43.0205f, 0.0f),new Vector3(-100f, -85.5f, 0.0f),new Vector3(136f, 119.5f, 0.0f),new Vector3(123f, -10.5f, 0.0f),new Vector3(-36.621f, 73.4857f, 0.0f),new Vector3(151f, 79.5f, 0.0f)};
			poses.Add(verts);
		}
		
		// B
		{
			Vector3 [] verts = {new Vector3(101f, -83.5001f, 0.0f),new Vector3(128f, -40.5001f, 0.0f),new Vector3(186f, -162.5f, 0.0f),new Vector3(63.0001f, -11.5001f, 0.0f),new Vector3(9.00003f, 36.5f, 0.0f),new Vector3(54.0001f, 58.4999f, 0.0f),new Vector3(-13f, -82.5f, 0.0f),new Vector3(-26f, 60.5f, 0.0f),new Vector3(-42f, -12.5f, 0.0f),new Vector3(-86f, -78.5f, 0.0f),new Vector3(-90f, -25.5f, 0.0f),new Vector3(-186f, -143.5f, 0.0f),new Vector3(100f, 162.5f, 0.0f),new Vector3(102f, 22.4999f, 0.0f),new Vector3(-77f, 28.5f, 0.0f),new Vector3(-79.9999f, 149.5f, 0.0f)};
			poses.Add(verts);
		}
		
		// BR
		{
			Vector3 [] verts = {new Vector3(130.019f, -16.3828f, 0.0f),new Vector3(129.775f, 34.3906f, 0.0f),new Vector3(83f, -91.5f, 0.0f),new Vector3(59.3546f, 24.0474f, 0.0f),new Vector3(-11.9587f, 35.6405f, 0.0f),new Vector3(14.2478f, 78.3279f, 0.0f),new Vector3(33.2294f, -76.6227f, 0.0f),new Vector3(-54.3701f, 37.1504f, 0.0f),new Vector3(-28.764f, -33.0588f, 0.0f),new Vector3(8f, -111.5f, 0.0f),new Vector3(-62.326f, -69.7548f, 0.0f),new Vector3(76f, -211.5f, 0.0f),new Vector3(86f, 189.5f, 0.0f),new Vector3(74.0653f, 73.6517f, 0.0f),new Vector3(-80.2844f, -17.1953f, 0.0f),new Vector3(-82f, 127.5f, 0.0f)};
			poses.Add(verts);
		}
		
		// R
		{
			Vector3 [] verts = {new Vector3(109f, 67.5f, 0.0f),new Vector3(32.3829f, 130.29f, 0.0f),new Vector3(276f, 38.5f, 0.0f),new Vector3(7.52148f, 63.5978f, 0.0f),new Vector3(-36.9931f, 6.69043f, 0.0f),new Vector3(-95f, 46.5f, 0.0f),new Vector3(82f, 1.5f, 0.0f),new Vector3(-68f, -29.5f, 0.0f),new Vector3(15.1125f, -41.1322f, 0.0f),new Vector3(97f, -55.5f, 0.0f),new Vector3(86f, -89.5f, 0.0f),new Vector3(227f, -72.5f, 0.0f),new Vector3(-130f, 78.5f, 0.0f),new Vector3(-76f, 72.5f, 0.0f),new Vector3(-56f, -68.5f, 0.0f),new Vector3(-153f, -31.5f, 0.0f)};
			poses.Add(verts);
		}
		
		
		// TR
		{
			Vector3 [] verts = {new Vector3(30f, 101.5f, 0.0f),new Vector3(-4f, 125.5f, 0.0f),new Vector3(151f, 228.5f, 0.0f),new Vector3(-38.0527f, 51.5096f, 0.0f),new Vector3(-31.5467f, -20.4464f, 0.0f),new Vector3(-79.4103f, -5.67914f, 0.0f),new Vector3(65.9517f, 51.2408f, 0.0f),new Vector3(-40f, -64.5f, 0.0f),new Vector3(46f, -20.5f, 0.0f),new Vector3(143f, 26.5f, 0.0f),new Vector3(115f, -14.5f, 0.0f),new Vector3(131f, 93.5f, 0.0f),new Vector3(-185f, 72.5f, 0.0f),new Vector3(-83f, 34.5f, 0.0f),new Vector3(-11f, -93.5f, 0.0f),new Vector3(-123f, -97.5f, 0.0f)};
			poses.Add(verts);
		}
		
		// T
		{
			Vector3 [] verts = {new Vector3(-110.669f, 70.183f, 0.0f),new Vector3(-132.067f, 24.138f, 0.0f),new Vector3(-204.9f, 137.907f, 0.0f),new Vector3(-63.9446f, 3.51334f, 0.0f),new Vector3(-4.35437f, -37.3402f, 0.0f),new Vector3(-46.2422f, -64.8067f, 0.0f),new Vector3(2.5575f, 83.4788f, 0.0f),new Vector3(33.3777f, -56.7643f, 0.0f),new Vector3(40.1022f, 17.6654f, 0.0f),new Vector3(75.4832f, 88.6597f, 0.0f),new Vector3(86.0944f, 36.5789f, 0.0f),new Vector3(166.548f, 165.68f, 0.0f),new Vector3(-78.8448f, -173.752f, 0.0f),new Vector3(-98.3757f, -35.1065f, 0.0f),new Vector3(79.9648f, -18.6246f, 0.0f),new Vector3(98.1065f, -138.294f, 0.0f)};
			poses.Add(verts);
		}
		
		
		
		// TL
		{
			Vector3 [] verts = {new Vector3(-125f, 19.5f, 0.0f),new Vector3(-122f, -32.5f, 0.0f),new Vector3(-252f, 73.5f, 0.0f),new Vector3(-55.8727f, -31.2969f, 0.0f),new Vector3(16.3314f, -33.8606f, 0.0f),new Vector3(-4.31839f, -79.496f, 0.0f),new Vector3(-42.5708f, 71.8539f, 0.0f),new Vector3(58.5975f, -30.0431f, 0.0f),new Vector3(24.3938f, 36.4032f, 0.0f),new Vector3(-29f, 131.5f, 0.0f),new Vector3(14f, 78.5f, 0.0f),new Vector3(-75f, 95.5f, 0.0f),new Vector3(141f, -140.5f, 0.0f),new Vector3(-64.2503f, -82.3538f, 0.0f),new Vector3(77.4961f, 27.122f, 0.0f),new Vector3(137f, 49.5f, 0.0f)};
			poses.Add(verts);
		}
		*/

		mesh.RecalculateNormals ();
	}

	void Start () {
		_playerMove = transform.parent.GetComponent<PlayerMove>();
		InitMesh ();	
	}

	float Heading( Vector3 v )
	{
		float theta = Mathf.Atan2 (v.y, v.x);
		if (theta < 0.0f)
				theta += Mathf.PI * 2.0f;
		float ang = Mathf.Rad2Deg*theta;
//		print (ang);
//		print (poses.Count);
		return ang;
	}

	float Discretize( float v, float step )
	{
		return Mathf.Round (v / step) * step;
	}

	float getRadius()
	{
		return size;
	}

	int GetPoseIndex()
	{
		Vector3 mouse = Camera.main.ScreenToWorldPoint(Input.mousePosition);
		Vector3 center = transform.position;
		Vector3 d = center - mouse;
		d = -_playerMove.velocityVector;
		if (d.magnitude < 1.0) {
//			print("Close enough..");
			return 0;
		}
//		transform.parent.transform.FindChild("Arrow").transform.localEulerAngles = new Vector3(0,0,Heading (d));
		int ind = (int)Discretize (Heading (d), 45) / 45;
		ind = (ind % 8) + 1;
//		print (ind);
		return ind;
	}

	
	void UpdateMesh () {
		float s = size;
		s = s / meshw;
		
		transform.localScale = new Vector3 (s, s, 1.0f);

		Vector3 [] verts = mesh.vertices;
		
		Vector3 [] target = (Vector3 [])poses [GetPoseIndex()];
		for (int i = 0; i < target.Length; i++)
			verts [i] = verts[i] + (target [i] - verts [i]) * 0.05f;
		mesh.vertices = verts;
		mesh.RecalculateBounds();

		headPosition = verts [headIndex] * s;
	}

	// Update is called once per frame
	void Update() {
				UpdateMesh ();
	}


}
