﻿using UnityEngine;
using System.Collections;

public class InstructionsController : MonoBehaviour {
	public Texture image;
	public float duration = 3.0f;
	private float t=0.0f;

	// Use this for initialization
	void Start () {
		t = 0.0f;
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnGUI() {
		t += Time.deltaTime;
		float lt = t - duration;

		if (lt < 0.0f)
			lt = 0.0f;

		float alpha = 1.0f - (lt / duration);
		Color guiColor = new Color(1,1,1,alpha);
		GUI.color = guiColor;

		float ratio = ((float)Screen.width / 1600.0f);
		int w = (int)(ratio * image.width);
		int h = (int)(ratio * image.height);

		GUI.DrawTexture (new Rect (1, 60, w, h), image);
	}

}
