﻿using UnityEngine;
using System.Collections;

public class ParrotController : MonoBehaviour {
	public float flapSpeed = 15.0f;
	public float flapAngle = 30.0f;
	
	private float t = 0.0f;
	private float nextSqueak = 3.0f;
	
	// Use this for initialization
	void Start () {
		
		
	}
	
	// Update is called once per frame
	void Update () {
		this.transform.FindChild("leftWing").transform.localEulerAngles = new Vector3(0,0,Mathf.Sin (Time.time * flapSpeed) * flapAngle);
		this.transform.FindChild("rightWing").transform.localEulerAngles = new Vector3(0,0,-Mathf.Sin (Time.time * flapSpeed) * flapAngle);
		
		t += Time.time;
		if (t >= nextSqueak) {
			//audio.Play ();
			nextSqueak += Random.Range(1.0f,4.0f);
			t = 0.0f;
		}
	}
}
