﻿using UnityEngine;
using System.Collections;

public class TextureScroll : MonoBehaviour {
	public Vector2 scrollSpeed;
	public LevelManager levelManager; 
	private Vector2 offset = new Vector2(0, 0);

	
	void Update () {
		offset += Time.deltaTime * scrollSpeed * levelManager.speed;
		renderer.material.SetTextureOffset("_MainTex", offset);
	}
}
