﻿using UnityEngine;
using System.Collections;

public class FitToScreen : MonoBehaviour {
	public Texture image;

	void OnGUI()
	{

		float iw = image.width, ih = image.height;
		float ir = (float)iw/(float)ih;
		float sar = Screen.width / (float)Screen.height;

		Vector2 pos = new Vector2();
		float mult = 1;
		if(sar > ir) {
			mult = Screen.height / ih;
			iw *= mult;
			ih *= mult;
			pos.x = Screen.width/2 - iw/2;
			pos.y = 0;
		} else {
			mult = Screen.width / iw;
			iw *= mult;
			ih *= mult;
			pos.x = 0;
			pos.y = Screen.height/2 - ih/2;
		}

		GUI.DrawTexture (new Rect (pos.x, pos.y, iw, ih), image);
	}
}
