﻿using UnityEngine;
using System.Collections;

public class Follower : MonoBehaviour {
	public GameObject target;
	public float moveSpeed = 10;
	public float minDistance = 5;
	public float noiseForce = 0;

	// Use this for initialization
	void Start () {
		transform.position = Random.insideUnitCircle * minDistance * 4;
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		Vector3 diff = target.transform.position - transform.position;
		if(diff.sqrMagnitude > minDistance * minDistance) {
			rigidbody.AddForce (diff * moveSpeed);
		} else {
			rigidbody.AddForce(Random.insideUnitSphere * noiseForce);
		}
	}
}
