﻿using UnityEngine;
using System.Collections;

public class TimeClock : MonoBehaviour {
	public float timePlayed = 0.0f;

	private float startTime;
	public GUIStyle largeFont;

	// Use this for initialization
	void Start () {
		reset();
		largeFont = new GUIStyle();
		largeFont.normal.textColor = Color.white;
		largeFont.font = (Font)Resources.Load ("FunSized", typeof(Font));
		print (largeFont.font);
	}

	public void reset() {
				startTime = Time.time;


		}
	// Update is called once per frame
	void OnGUI() {
		timePlayed = Time.time - startTime;
		//GUI.color = Color.yellow;
		largeFont.fontSize = (int)(45.0f * (float)Screen.width / 1600.0f);
		GUI.Label(new Rect(10, 10, 150, 150), "Time: " + timePlayed.ToString("f1") + " s", largeFont);
	}
}
